/*
 * Copyright (c) 2007-2010 Sonatype, Inc.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
package org.sonatype.tycho.p2.publisher;

import java.util.Collection;
import java.util.Collections;

import org.sonatype.aether.graph.DependencyNode;
import org.sonatype.tycho.p2.publisher.model.Advice;

public class NoOpPublisherLifecycleParticipant
    implements PublisherLifecycleParticipant
{

    public Collection<Advice> getAdvices( final DependencyNode root )
    {
        return Collections.emptyList();
    }

    public DependencyNode cleanupDependencyTree( final DependencyNode root )
    {
        return root;
    }

    public DependencyNode processDependencyTree( final DependencyNode root )
    {
        return root;
    }

}
